// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Stack;
import bdc.scheme.Scheme;
import bdc.scheme.exception.ArgumentTypeException;
import bdc.scheme.expression.Procedure1;

/**
    (atan x) (atan x y)
*/
public class Atan extends Procedure1
{
    public Object apply1 (Stack stack) throws ArgumentTypeException
    {
        Object o1 = stack.array[stack.inUse-1];
        return new Double(Math.atan(Scheme.number(o1, this).doubleValue()));
    }

    public Object apply2 (Stack stack) throws ArgumentTypeException
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        return new Double(Math.atan2(Scheme.number(o1, this).doubleValue(),
                                     Scheme.number(o2, this).doubleValue()));
    }
}
