// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Stack;
import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.exception.BoundsException;
import bdc.scheme.expression.Procedure3;
import java.util.List;

/**
    (vector-set&33; x y z)
*/
public class VectorSet extends Procedure3
{
    public Object apply3 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        Object o3 = stack.array[stack.inUse-3];
        List list = Scheme.list(o1, this);
        int size  = list.size();
        int k     = Scheme.integer(o2, this);

        if ((k < 0) || (k >= size)) {
            throw new BoundsException(o1, size, k);
        }
        list.set(k, o3);

        return Scheme.Unspecified;
    }
}
