;;; Copyright (c) 1996-2002 Brian D. Carlstrom

(define (test) (load "bdc/scheme/test.scm"))
boolean?
symbol?
char?
pair?
number?
string?
procedure?

#t
#f
(define symbol 'foo)
symbol
(define string "bar")
string
(define char (string-ref string 0))
char
(define vector (make-vector 5))
vector
(define pair (cons symbol string))
pair
(define number 42)
number
(define procedure (lambda (x) x))
procedure

(boolean? #t)
(boolean? #f)
(boolean? symbol)
(boolean? char)
(boolean? vector)
(boolean? pair)
(boolean? number)
(boolean? string)
(boolean? procedure)

(symbol? #t)
(symbol? #f)
(symbol? symbol)
(symbol? char)
(symbol? vector)
(symbol? pair)
(symbol? number)
(symbol? string)
(symbol? procedure)

(char? #t)
(char? #f)
(char? symbol)
(char? vector)
(char? char)
(char? pair)
(char? number)
(char? string)
(char? procedure)

(vector? #t)
(vector? #f)
(vector? symbol)
(vector? char)
(vector? vector)
(vector? pair)
(vector? number)
(vector? string)
(vector? procedure)

(pair? #t)
(pair? #f)
(pair? symbol)
(pair? char)
(pair? vector)
(pair? pair)
(pair? number)
(pair? string)
(pair? procedure)

(number? #t)
(number? #f)
(number? symbol)
(number? char)
(number? vector)
(number? pair)
(number? number)
(number? string)
(number? procedure)

(string? #t)
(string? #f)
(string? symbol)
(string? char)
(string? vector)
(string? pair)
(string? number)
(string? string)
(string? procedure)

(procedure? #t)
(procedure? #f)
(procedure? symbol)
(procedure? char)
(procedure? vector)
(procedure? pair)
(procedure? number)
(procedure? string)
(procedure? procedure)

+
(+)
(+ 1)
(+ 1 2)

-
(- 1)
(- 1 2)

*
(*)
(* 1)
(* 1 2)

=
(= 0 0)
(= 0 1)

vector-length
(vector-length vector)
vector-ref
(vector-ref vector 2)
vector-set!
(vector-set! vector 0 string)

(set! string (make-string 10 (string-ref " " 0)))
string-length
(string-length string)
string-ref
(string-ref string 5)
string-set!
(string-set! string 1 (string-ref "b" 0))

car
(car pair)
cdr
(cdr pair)
(define eol '())
null?
(null? #t)
(null? #f)
(null? symbol)
(null? char)
(null? vector)
(null? pair)
(null? number)
(null? string)
(null? procedure)
(null? eol)

load

(load "bdc/scheme/fib.scm")
fib
(fib 0)
(fib 1)
(fib 2)
(fib 3)
(fib 4)
(fib 5)
(fib 6)

(load "bdc/scheme/fact.scm")
fact
(fact 0)
(fact 1)
(fact 2)
(fact 3)
(fact 4)
(fact 5)
(fact 6)

'foo
'()

(define foo "bar")
foo
(set! foo "foo")
foo
(define (foo) "bar")
foo
(foo)

(if (= 0 1) "foo" "bar")
(if "baz" "foo" "bar")

(define i (lambda (x) x))
(i i)
(i 0)
(define l (lambda x x))
(l 1 2 3 4)
(l)

(begin)
(begin 1 2 3 4)

(do () (#t))
(do () (#t foo) (set! foo 5))
(set! foo 0)
(do ((a 0)) ((= foo 5) foo) (set! foo 5))
(do ((a 0 (+ a 1))) ((= a 5) foo) (set! foo a))
(do ((vec (make-vector 5))
     (i 0 (+ i 1)))
    ((= i 5) vec)
  (vector-set! vec i i))
;; =>  #(0 1 2 3 4)
(let ((x '(1 3 5 7 9)))
  (do ((x x (cdr x))
       (sum 0 (+ sum (car x))))
      ((null? x) sum)))
;; =>  25

(let () "foo")
(let ((a 5)) a)
(let ((a 5)
      (b 6)) (+ a b))

(cond)
(cond (else))
(cond (else "foo"))
(cond (#t "foo") (else "bar"))
(cond (#f "foo") (else "bar"))
(cond (#f "foo")
      (#t "baz")
      (else "bar"))

(and)
(and "foo")
(and #t "foo")
(and "foo" #f)
(and "foo" #t )

(or "foo" #f)
(or #t "foo")
(or #f)
(or #f #f)

(define (cat filename)
  (do ((port (open-input-file filename))
       (exit #f))
      (exit (close-input-port port))
    (let ((char (read-char port)))
      (if (eof-object? char)
          (set! exit #t)
          (write-char char)))))
